## xenomai 2.4.4

=== examples/native/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = trivial-periodic sigxcpu rtprint

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES =

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --xeno-cflags) $(MY_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --xeno-ldflags) $(MY_LDFLAGS) -lnative

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### SPECIAL TARGET RULES ######
rtprint: rtprint.c
	$(CC) $(CFLAGS) $? $(LDFLAGS) -lrtdk -o $@



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
ifeq ($(findstring 2.6,$(KSRC)),2.6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers
	$(RM) -R .tmp*

endif

=== ksrc/arch/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENOMAI) += generic/

else

# Makefile frag for Linux v2.4

subdir-y += generic

include $(TOPDIR)/Rules.make

endif

=== ksrc/drivers/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENOMAI) += serial/ testing/ can/

else

# Makefile frag for Linux v2.4

mod-subdirs := serial testing can

subdir-$(CONFIG_XENO_DRIVERS_16550A) += serial

subdir-$(CONFIG_XENO_DRIVERS_TIMERBENCH) += testing
subdir-$(CONFIG_XENO_DRIVERS_IRQBENCH)   += testing
subdir-$(CONFIG_XENO_DRIVERS_SWITCHTEST) += testing

subdir-$(CONFIG_XENO_DRIVERS_CAN) += can

include $(TOPDIR)/Rules.make

endif

=== ksrc/arch/blackfin/Makefile ===

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o switch.o

xeno_hal-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

=== ksrc/arch/x86/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

ifeq ($(CONFIG_X86_64),y)
X86_MODE := 64
else
X86_MODE := 32
endif

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal_$(X86_MODE).o hal-common.o usercopy_$(X86_MODE).o

xeno_hal-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi_$(X86_MODE).o

xeno_hal-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

USE_STANDARD_AS_RULE := true

O_TARGET := built-in.o

obj-y := hal_32.o hal-common.o

obj-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi_32.o

obj-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o

export-objs := $(obj-y) $(obj-m)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

endif

=== ksrc/drivers/testing/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

obj-$(CONFIG_XENO_DRIVERS_TIMERBENCH) += xeno_timerbench.o
obj-$(CONFIG_XENO_DRIVERS_IRQBENCH)   += xeno_irqbench.o
obj-$(CONFIG_XENO_DRIVERS_SWITCHTEST) += xeno_switchtest.o
obj-$(CONFIG_XENO_DRIVERS_KLATENCY)   += xeno_klat.o

xeno_timerbench-y := timerbench.o

xeno_irqbench-y := irqbench.o

xeno_switchtest-y := switchtest.o

xeno_klat-y := klat.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_TIMERBENCH) += xeno_timerbench.o
obj-$(CONFIG_XENO_DRIVERS_IRQBENCH)   += xeno_irqbench.o
obj-$(CONFIG_XENO_DRIVERS_SWITCHTEST) += xeno_switchtest.o
obj-$(CONFIG_XENO_DRIVERS_KLATENCY)   += xeno_klat.o
xeno_timerbench-objs := timerbench.o

xeno_irqbench-objs := irqbench.o

xeno_switchtest-objs := switchtest.o

xeno_klat-objs := klat.o

export-objs := $(xeno_timerbench-objs) $(xeno_irqbench-objs) \
	$(xeno_switchtest-objs) $(xeno_klat-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_timerbench.o: $(xeno_timerbench-objs)
	$(LD) -r -o $@ $(xeno_timerbench-objs)

xeno_irqbench.o: $(xeno_irqbench-objs)
	$(LD) -r -o $@ $(xeno_irqbench-objs)

xeno_switchtest.o: $(xeno_switchtest-objs)
	$(LD) -r -o $@ $(xeno_switchtest-objs)

xeno_klat.o: $(xeno_klat-objs)
	$(LD) -r -o $@ $(xeno_klat-objs)

endif

=== ksrc/skins/psos+/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENO_SKIN_PSOS) += xeno_psos.o

xeno_psos-y := module.o asr.o event.o pt.o queue.o rn.o task.o tm.o sem.o

xeno_psos-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_PSOS) := xeno_psos.o

list-multi := xeno_psos.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

xeno_psos-objs := module.o asr.o event.o pt.o queue.o rn.o task.o tm.o sem.o $(opt_objs-y)

export-objs := $(xeno_psos-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_psos.o: $(xeno_psos-objs)
	$(LD) -r -o $@ $(xeno_psos-objs)

endif

=== ksrc/skins/vxworks/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENO_SKIN_VXWORKS) += xeno_vxworks.o

xeno_vxworks-y := errnoLib.o intLib.o kernelLib.o module.o msgQLib.o semLib.o \
		sysLib.o taskHookLib.o taskInfo.o taskLib.o tickLib.o wdLib.o

xeno_vxworks-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -I$(src)/..

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_VXWORKS) := xeno_vxworks.o

list-multi := xeno_vxworks.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

xeno_vxworks-objs := errnoLib.o intLib.o kernelLib.o module.o msgQLib.o semLib.o \
		sysLib.o taskHookLib.o taskInfo.o taskLib.o tickLib.o wdLib.o $(opt_objs-y)

export-objs := $(xeno_vxworks-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I..

include $(TOPDIR)/Rules.make

xeno_vxworks.o: $(xeno_vxworks-objs)
	$(LD) -r -o $@ $(xeno_vxworks-objs)

endif

=== examples/rtdm/profiles/serial/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = cross-link

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES =

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --xeno-cflags) $(MY_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --xeno-ldflags) $(MY_LDFLAGS) -lnative -lrtdm

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
ifeq ($(findstring 2.6,$(KSRC)),2.6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers
	$(RM) -R .tmp*

endif

## xenomai 2.4.8

=== ksrc/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENOMAI) += arch/ nucleus/ skins/

else

# Makefile frag for Linux v2.4

subdir-$(CONFIG_XENOMAI) += arch

subdir-$(CONFIG_XENO_OPT_NUCLEUS) += nucleus

mod-subdirs := skins
subdir-y += skins

include $(TOPDIR)/Rules.make

endif

=== examples/common/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = hw_direct_io

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES =

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --xeno-cflags) $(MY_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --xeno-ldflags) $(MY_LDFLAGS) -O

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
ifeq ($(findstring 2.6,$(KSRC)),2.6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers
	$(RM) -R .tmp*

endif

=== examples/posix/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = satch

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES = satch

### Note: to override the kernel source path, use "make KSRC=..."

all::

satch: satch.c


###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=-DCONSUMER $(shell $(XENOCONFIG) --posix-cflags) $(APP_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --posix-ldflags) $(APP_LDFLAGS)

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
PATCHLEVEL:=$(shell sed 's/PATCHLEVEL = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
ifeq ($(PATCHLEVEL),6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -DPRODUCER -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE) SUBDIRS=$(PWD) modules
	$(RM) *.o

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  := $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers
	$(RM) -R .tmp*
	$(RM) .runinfo

endif

=== ksrc/nucleus/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENO_OPT_NUCLEUS) += xeno_nucleus.o

xeno_nucleus-y := heap.o intr.o module.o pod.o synch.o thread.o timebase.o timer.o

xeno_nucleus-$(CONFIG_XENO_OPT_PERVASIVE) += shadow.o

xeno_nucleus-$(CONFIG_XENO_OPT_PIPE) += pipe.o

xeno_nucleus-$(CONFIG_XENO_OPT_MAP) += map.o

xeno_nucleus-$(CONFIG_XENO_OPT_REGISTRY) += registry.o

xeno_nucleus-$(CONFIG_XENO_OPT_SELECT) += select.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_OPT_NUCLEUS) := xeno_nucleus.o

list-multi := xeno_nucleus.o

xeno_nucleus-objs := heap.o intr.o module.o pod.o synch.o thread.o timebase.o timer.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += shadow.o
opt_objs-$(CONFIG_XENO_OPT_PIPE) += pipe.o
opt_objs-$(CONFIG_XENO_OPT_MAP) += map.o
opt_objs-$(CONFIG_XENO_OPT_REGISTRY) += registry.o
opt_objs-$(CONFIG_XENO_OPT_SELECT) += select.o

xeno_nucleus-objs += $(opt_objs-y)

export-objs := $(xeno_nucleus-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_nucleus.o: $(xeno_nucleus-objs)
	$(LD) -r -o $@ $(xeno_nucleus-objs)

endif

=== ksrc/skins/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENOMAI) += native/ posix/ rtdm/ psos+/ vrtx/ vxworks/ uitron/ rtai/

else

# Makefile frag for Linux v2.4

subdir-$(CONFIG_XENO_SKIN_NATIVE) += native
subdir-$(CONFIG_XENO_SKIN_POSIX) += posix
subdir-$(CONFIG_XENO_SKIN_RTDM) += rtdm
subdir-$(CONFIG_XENO_SKIN_PSOS) += psos+
subdir-$(CONFIG_XENO_SKIN_VRTX) += vrtx
subdir-$(CONFIG_XENO_SKIN_VXWORKS) += vxworks
subdir-$(CONFIG_XENO_SKIN_UITRON) += uitron
subdir-$(CONFIG_XENO_SKIN_RTAI) += rtai

include $(TOPDIR)/Rules.make

endif

=== examples/rtdm/driver-api/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = tut01-skeleton-app tut02-skeleton-app

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES = heartbeat tut01-skeleton-drv tut02-skeleton-drv

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --xeno-cflags) $(MY_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --xeno-ldflags) $(MY_LDFLAGS) -lnative -lrtdm

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
ifeq ($(findstring 2.6,$(KSRC)),2.6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers
	$(RM) -R .tmp*

endif

=== ksrc/arch/arm/Makefile ===
obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o switch.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

=== ksrc/arch/ia64/Makefile ===
ifeq ($(PATCHLEVEL),6)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

EXTRA_AFLAGS += -Iarch/ia64/kernel

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o switch.o

endif

=== ksrc/drivers/serial/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

obj-$(CONFIG_XENO_DRIVERS_16550A) += xeno_16550A.o

xeno_16550A-y := 16550A.o

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_16550A) := xeno_16550A.o

xeno_16550A-objs := 16550A.o

export-objs := $(xeno_16550A-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_16550A.o: $(xeno_16550A-objs)
	$(LD) -r -o $@ $(xeno_16550A-objs)

endif

=== ksrc/skins/native/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENO_SKIN_NATIVE) += xeno_native.o

xeno_native-y := module.o task.o timer.o

xeno_native-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_PIPE) += pipe.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_SEM) += sem.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_EVENT) += event.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_MUTEX) += mutex.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_COND) += cond.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_QUEUE) += queue.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_HEAP) += heap.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_ALARM) += alarm.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_INTR) += intr.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_NATIVE) := xeno_native.o

xeno_native-objs := module.o task.o timer.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_PIPE) += pipe.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_SEM) += sem.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_EVENT) += event.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_MUTEX) += mutex.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_COND) += cond.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_QUEUE) += queue.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_HEAP) += heap.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_ALARM) += alarm.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_INTR) += intr.o

xeno_native-objs += $(opt_objs-y)

export-objs := $(xeno_native-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_native.o: $(xeno_native-objs)
	$(LD) -r -o $@ $(xeno_native-objs)

endif

=== ksrc/skins/posix/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENO_SKIN_POSIX) += xeno_posix.o

xeno_posix-y := sched.o thread_attr.o thread.o mutex_attr.o mutex.o \
		cond_attr.o cond.o sem.o cancel.o once.o signal.o tsd.o \
		clock.o timer.o registry.o mq.o module.o apc.o

xeno_posix-$(CONFIG_XENO_OPT_POSIX_SHM) += shm.o

xeno_posix-$(CONFIG_XENO_OPT_POSIX_INTR) += intr.o

xeno_posix-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(srctree)/include/xenomai/posix -I$(src)/.. -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_POSIX) := xeno_posix.o

list-multi := xeno_posix.o

xeno_posix-objs := sched.o thread_attr.o thread.o mutex_attr.o mutex.o \
		cond_attr.o cond.o sem.o cancel.o once.o signal.o tsd.o \
		clock.o timer.o registry.o mq.o module.o apc.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

opt_objs-$(CONFIG_XENO_OPT_POSIX_SHM) += shm.o

opt_objs-$(CONFIG_XENO_OPT_POSIX_INTR) += intr.o

xeno_posix-objs += $(opt_objs-y)

export-objs := $(xeno_posix-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I.. -I$(TOPDIR)/include/xenomai/posix

include $(TOPDIR)/Rules.make

xeno_posix.o: $(xeno_posix-objs)
	$(LD) -r -o $@ $(xeno_posix-objs)

endif

=== ksrc/skins/rtai/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENO_SKIN_RTAI) += xeno_rtai.o

xeno_rtai-y := intr.o module.o task.o timer.o

xeno_rtai-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

xeno_rtai-$(CONFIG_XENO_OPT_RTAI_FIFO) += fifo.o

xeno_rtai-$(CONFIG_XENO_OPT_RTAI_SEM) += sem.o

xeno_rtai-$(CONFIG_XENO_OPT_RTAI_SHM) += shm.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_RTAI) := xeno_rtai.o

list-multi := xeno_rtai.o

xeno_rtai-objs := intr.o module.o task.o timer.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o
opt_objs-$(CONFIG_XENO_OPT_RTAI_FIFO) += fifo.o
opt_objs-$(CONFIG_XENO_OPT_RTAI_SEM) += sem.o
opt_objs-$(CONFIG_XENO_OPT_RTAI_SHM) += shm.o

xeno_rtai-objs += $(opt_objs-y)

export-objs := $(xeno_rtai-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_rtai.o: $(xeno_rtai-objs)
	$(LD) -r -o $@ $(xeno_rtai-objs)

endif

## xenomai 2.5.4

=== debian/changelog ===
xenomai (2.5.4-3squeeze1) stable; urgency=low

  * Fixed kernel patch for Debian's 2.6.32 (Closes: #614010, #621869)

 -- Roland Stigge <stigge@antcom.de>  Tue, 26 Apr 2011 20:38:29 +0200

xenomai (2.5.4-3) unstable; urgency=low

  * Fix x86 boot problems (Closes: #594914)

 -- Roland Stigge <stigge@antcom.de>  Sat, 04 Sep 2010 14:26:25 +0200

xenomai (2.5.4-2) unstable; urgency=low

  * Fixed runlevels in debian/libxenomai1.xenomai.init (Closes: #592360)

 -- Roland Stigge <stigge@antcom.de>  Thu, 19 Aug 2010 23:25:42 +0200

xenomai (2.5.4-1) unstable; urgency=low

  * New upstream release
  * Standards-Version: 3.9.1

 -- Roland Stigge <stigge@antcom.de>  Wed, 04 Aug 2010 22:29:28 +0200

xenomai (2.5.3-2) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format

 -- Roland Stigge <stigge@antcom.de>  Sat, 15 May 2010 20:13:42 +0200

xenomai (2.5.3-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sat, 15 May 2010 20:13:10 +0200

xenomai (2.5.2-2) unstable; urgency=low

  * Added patch from Stefan Kisdaroczi <kisda@hispeed.ch>:
    - Create group xenomai on install
    - Added a init-script which sets /sys/.../xenomai_gid if
      /sys/.../xenomai_gid exists
    - Added a modprobe-script that adds the xenomai_gid parameter if the user
      did call modprobe without xenomai_gid=

 -- Roland Stigge <stigge@antcom.de>  Sun, 02 May 2010 17:06:14 +0200

xenomai (2.5.2-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Mon, 29 Mar 2010 20:51:07 +0200

xenomai (2.5.1-4) unstable; urgency=low

  * Added patches by Stefan Kisdaroczi <kisda@hispeed.ch>:
    - debian/copyright: Typo and email address (Closes: #571099)
    - debian/control: ia64 support removed (Closes: #571104)
    - debian/rules: Added dpkg-cross support

 -- Roland Stigge <stigge@antcom.de>  Wed, 24 Feb 2010 22:20:10 +0100

xenomai (2.5.1-3) unstable; urgency=low

  * xenomai-runtime: Replaced "xenomai-" prefixed executables with
    wrapper script /usr/bin/xeno to call original executables from
    /usr/lib/xenomai/, e.g. "xeno latency"
  * debian/prepare-patch.sh: Synchronized from upstream (Closes: #569721)
  * Removed 2.6.24 adeos-ipipe patches
  * Enabled patching/use of Debian's kernel (2.6.32)

 -- Roland Stigge <stigge@antcom.de>  Sun, 14 Feb 2010 13:35:15 +0100

xenomai (2.5.1-2) unstable; urgency=low

  * xenomai-runtime: Renamed /usr/bin/* to /usr/bin/xenomai-* (Closes: #569357)

 -- Roland Stigge <stigge@antcom.de>  Fri, 12 Feb 2010 21:18:00 +0100

xenomai (2.5.1-1) unstable; urgency=low

  * New upstream release (Closes: #553334, #566566, #536731)
  * debian/control: Standards-Version: 3.8.4

 -- Roland Stigge <stigge@antcom.de>  Sat, 06 Feb 2010 11:05:50 +0100

xenomai (2.4.8-2) unstable; urgency=low

  * debian/libxenomai1.{postinst,postrm}: "set -e"
  * debian/control: linux-patch-xenomai: Section: kernel

 -- Roland Stigge <stigge@antcom.de>  Wed, 24 Jun 2009 17:47:41 +0200

xenomai (2.4.8-1) unstable; urgency=low

  * New upstream release
    - includes limits.h include as in patch from Peter Green (Closes: #527654)
  * debian/control:
    - Standards-Version: 3.8.2

 -- Roland Stigge <stigge@antcom.de>  Mon, 22 Jun 2009 22:50:23 +0200

xenomai (2.4.4-3) unstable; urgency=low

  * debian/rules: Fixed concurrent ./configure + make runs, thanks to Albin
    Tonnerre (Closes: #486461)

 -- Roland Stigge <stigge@antcom.de>  Mon, 16 Jun 2008 11:44:01 +0200

xenomai (2.4.4-2) unstable; urgency=low

  * Backported kernel 2.6.24 patches for x86, powerpc and arm (for lenny) from
    xenomai 2.4.3
  * debian/control: Standards-Version: 3.8.0

 -- Roland Stigge <stigge@antcom.de>  Thu, 12 Jun 2008 14:27:12 +0200

xenomai (2.4.4-1) unstable; urgency=low

  * New upstream release
  * debian/rules: configure --enable-arm-mach=generic for ARM
  * debian/control: Standards-Version: 3.8.0

 -- Roland Stigge <stigge@antcom.de>  Mon, 09 Jun 2008 14:28:01 +0200

xenomai (2.4.4~svn20080526-1) experimental; urgency=low

  * New upstream snapshot

 -- Roland Stigge <stigge@antcom.de>  Mon, 26 May 2008 11:58:30 +0200

xenomai (2.4.3-7) unstable; urgency=low

  * Included patch from Riku Voipio to fix ARM compile issues
    (Closes: #477720)

 -- Roland Stigge <stigge@antcom.de>  Thu, 24 Apr 2008 23:18:01 +0200

xenomai (2.4.3-6) unstable; urgency=low

  * Added lintian override for recursive include directories (necessary
    according to upstream)
  * Added missing man pages (can be removed when integrated upstream)
  * debian/rules: Fixed klatency/run script to be proper shell script

 -- Roland Stigge <stigge@antcom.de>  Tue, 22 Apr 2008 12:23:22 +0200

xenomai (2.4.3-5) unstable; urgency=low

  * Install xeno-config into libxenomai-dev where the executable is

 -- Roland Stigge <stigge@antcom.de>  Sat, 19 Apr 2008 22:15:07 +0200

xenomai (2.4.3-4) unstable; urgency=low

  * Move /usr/lib/xenomai to original upstream /usr/share/xenomai

 -- Roland Stigge <stigge@antcom.de>  Fri, 18 Apr 2008 19:51:49 +0200

xenomai (2.4.3-3) unstable; urgency=low

  * debian/rules: Separated prepare-patch.sh calls for individual
    architectures (Closes: #473098)

 -- Roland Stigge <stigge@antcom.de>  Thu, 10 Apr 2008 10:01:33 +0200

xenomai (2.4.3-2) unstable; urgency=low

  * Enable x86 patches for both i386 and amd64 (Closes: #473098)

 -- Roland Stigge <stigge@antcom.de>  Tue, 01 Apr 2008 10:04:51 +0200

xenomai (2.4.3-1) unstable; urgency=low

  * New upstream release
  * Added debian/watch

 -- Roland Stigge <stigge@antcom.de>  Tue, 25 Mar 2008 14:13:50 +0100

xenomai (2.4.2-3) unstable; urgency=low

  * Fixed bashisms by using "#!/bin/bash" (Closes: #471871)

 -- Roland Stigge <stigge@antcom.de>  Sat, 22 Mar 2008 17:01:11 +0100

xenomai (2.4.2-2) unstable; urgency=low

  * debian/copyright: Refined Copyrights
  * debian/control: Added ia64 to remaining relevant Architecture lines


=== debian/control ===
Source: xenomai
Section: devel
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 7), dh-kpatches, findutils (>= 4.2.28)
Standards-Version: 3.9.1
Homepage: http://www.xenomai.org/

Package: xenomai-runtime
Section: devel
Architecture: amd64 arm armeb armel i386 powerpc
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Xenomai runtime utilities
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the runtime programs and the testsuite for the Xenomai
 realtime system.

Package: linux-patch-xenomai
Section: kernel
Architecture: all
Depends: ${kpatch:Depends}, ${misc:Depends}
Suggests: xenomai, linux-source-2.6, kernel-package
Description: Linux kernel patches for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains patches for 2.6 series kernels - These are intended for
 use with kernel-package and a virgin Linux source tree. Note: These patches
 include the base adeos-ipipe patch along with all the additional material
 normally added by the prepare-kernel.sh script.
 .
 This package contains the following patches:
 .

Package: libxenomai1
Section: libs
Architecture: amd64 arm armeb armel i386 powerpc
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Shared libraries for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the shared libraries.

Package: libxenomai-dev
Section: libdevel
Architecture: amd64 arm armeb armel i386 powerpc
Depends: libxenomai1 (= ${binary:Version}), ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Headers and static libs for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains development files (header files), the static libraries
 and scripts used to compile realtime applications.

Package: xenomai-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: xenomai
Conflicts: xenomai-docs
Replaces: xenomai-docs
Description: Xenomai documentation
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 Documentation for Xenomai realtime API.

=== debian/rules ===
#!/usr/bin/make -f

# Author: Paul Corner <paul_c@gna.org>
# Created on: Sat Mar 3 12:00 GMT 2007
# License: GPL Ver. 2

#export DH_VERBOSE=1

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_HOST_ARCH), i386)
# Note: Would like to use --includedir=/usr/include/xenomai, but
# there appears to be a `make install` problem.
	CONFIG_OPTS = \
	            --enable-x86-tsc
endif
ifeq ($(DEB_HOST_ARCH), amd64)
	CONFIG_OPTS = \
	            --enable-smp \
	            --enable-x86-tsc \
	            --enable-x86-sep
endif
ifeq ($(DEB_HOST_ARCH), powerpc)
	CONFIG_OPTS =
endif
ifeq ($(DEB_HOST_ARCH), armeb)
	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
endif
ifeq ($(DEB_HOST_ARCH), armel)
	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
endif
ifeq ($(DEB_HOST_ARCH), arm)
	CONFIG_OPTS = --enable-arm-mach=generic
endif
	CONFIG_OPTS += --prefix=/usr \
	            --includedir=/usr/include/xenomai \
	            --mandir=/usr/share/man \
		    --with-testdir=/usr/lib/xenomai

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE)
endif

build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: config.status patch-stamp
	dh_testdir
	$(MAKE)
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: config.status
	dh_testdir
	touch build-indep-stamp

patch-stamp:
	dh_testdir
	cp debian/linux-patch-xenomai.kpatches.in debian/linux-patch-xenomai.kpatches
	for i in arm i386 powerpc x86_64 x86 ; do \
		bash $(CURDIR)/debian/prepare-patch.sh $$i ; \
	done
	touch patch-stamp

config.status: configure-stamp
configure-stamp:
	dh_testdir
	./configure $(CONFIG_OPTS)
	touch configure-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f *-stamp
	dh_clean
	if test -f Makefile ; then \
	    $(MAKE) distclean ; \
	fi
	rm -fR $(CURDIR)/tmp
	rm -f $(CURDIR)/*.patch
	rm -f $(CURDIR)/debian/*.kpatches

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp/
	dh_install --sourcedir=$(CURDIR)/debian/tmp
	# xeno-config should be only in libxenomai-dev
	rm -f $(CURDIR)/debian/xenomai-runtime/usr/bin/xeno-config
	rm -f $(CURDIR)/debian/xenomai-runtime/usr/share/man/man1/xeno-config.1
	for f in $(CURDIR)/ksrc/nucleus/udev/*.rules ; do \
	    cat $$f >> $(CURDIR)/debian/libxenomai1/etc/udev/xenomai.rules ; \
	done
	install -m 644 debian/libxenomai1.modprobe $(CURDIR)/debian/libxenomai1/etc/modprobe.d/xenomai.conf
	# remove empty directory
	rm -rf $(CURDIR)/debian/xenomai-doc/usr/share/doc/xenomai-doc/ps
	cp debian/libxenomai1.lintian $(CURDIR)/debian/libxenomai1/usr/share/lintian/overrides/libxenomai1
	cp debian/libxenomai-dev.lintian $(CURDIR)/debian/libxenomai-dev/usr/share/lintian/overrides/libxenomai-dev
	dh_installkpatches

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i -A CREDITS README.INSTALL TROUBLESHOOTING
	dh_link -i
	dh_installchangelogs -i
	dh_strip -i
	dh_compress -i -X.pdf
	dh_fixperms -i
	dh_makeshlibs -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
#	 Here follows a little hackery to insert the patch list        
#	 into the control file for linux-patch-xenomai
	cat $(CURDIR)/debian/linux-patch-xenomai.kpatches | \
	    sed -e 's/^$$/./;s/^/ /' >> \
	        $(CURDIR)/debian/linux-patch-xenomai/DEBIAN/control
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -s
	dh_testroot -s
	dh_installinit -s --name=xenomai
	dh_installman -s
	dh_installdocs -s -A CREDITS README.INSTALL TROUBLESHOOTING
	dh_link -s
	dh_installchangelogs -s
	dh_strip -s
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
#	 Echo config options to control.
	echo " ." >> $(CURDIR)/debian/libxenomai1/DEBIAN/control
	echo " Compiled with the following options." >> \
	        $(CURDIR)/debian/libxenomai1/DEBIAN/control
	echo "$(CONFIG_OPTS)" | awk '{ for ( i=1 ; i<=NF ; i++ ) print "   "$$i }' >> \
	        $(CURDIR)/debian/libxenomai1/DEBIAN/control
#	 End of hackery.
	dh_md5sums -s
	dh_builddeb -s

# We have nothing to do by default.

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
